unit About;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI, ExtCtrls;

type
  TAboutForm = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormClick(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutForm: TAboutForm;

implementation

{$R *.dfm}

procedure TAboutForm.FormClick(Sender: TObject);
begin
  AboutForm.Hide;
end;

procedure TAboutForm.Label2Click(Sender: TObject);
begin
  // http://delphi.about.com/library/weekly/aa112498.htm?
  if (Sender is TLabel) then
    with (Sender as Tlabel) do
      ShellExecute(Application.Handle,
             PChar('open'),
             PChar(Hint),
             PChar(0),
             nil,
             SW_NORMAL);
end;

procedure TAboutForm.Timer1Timer(Sender: TObject);
var
  CurrentColorInt, NewLabelColorInt: integer;
  CurrentColorRed, CurrentColorGreen, CurrentColorBlue: integer;
  NewColorRed, NewColorGreen, NewColorBlue: integer;
begin
  CurrentColorInt   := ColorToRGB(Panel1.Color);
  CurrentColorRed   := CurrentColorInt and 255;
  CurrentColorGreen := (CurrentColorInt shr 8)  and 255;
  CurrentColorBlue  := (CurrentColorInt shr 16) and 255;

  NewColorRed   := (CurrentColorRed   - Random(4) + Random(2)) and 255;
  NewColorGreen := (CurrentColorGreen - Random(4) + Random(4)) and 255;
  NewColorBlue  := (CurrentColorBlue  - Random(6) + Random(2)) and 255;

  Panel1.Color := (NewColorBlue shl 16) + (NewColorGreen shl 8) + NewColorRed;
  NewLabelColorInt  := (((128 + NewColorBlue) and 255) shl 16) + (((96 + NewColorGreen) and 255) shl 8) + ((160 + NewColorRed) and 255);
  Label1.Font.Color := NewLabelColorInt;
  Label2.Font.Color := NewLabelColorInt;
  Label3.Font.Color := NewLabelColorInt;
end;

procedure TAboutForm.FormHide(Sender: TObject);
begin
  Timer1.Enabled := False;
end;

procedure TAboutForm.FormShow(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

end.
